package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.SysAdminFunc;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class SysAdminFuncSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<SysAdminFunc> selectCond;
	private JSONObject customsearchval;
	public SysAdminFuncSearchFilter(){
		this.page =new Page<SysAdminFunc>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<SysAdminFunc>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_sysadminfuncname_like;

	public void setN_sysadminfuncname_like(String n_sysadminfuncname_like) {
        this.n_sysadminfuncname_like = n_sysadminfuncname_like;
        if(!StringUtils.isEmpty(this.n_sysadminfuncname_like)){
            this.selectCond.like("sysadminfuncname", n_sysadminfuncname_like);
        }
    }
	private String n_sysadminid_eq;

	public void setN_sysadminid_eq(String n_sysadminid_eq) {
        this.n_sysadminid_eq = n_sysadminid_eq;
        if(!StringUtils.isEmpty(this.n_sysadminid_eq)){
            this.selectCond.eq("sysadminid", n_sysadminid_eq);
        }
    }
	private String n_sysadminname_eq;

	public void setN_sysadminname_eq(String n_sysadminname_eq) {
        this.n_sysadminname_eq = n_sysadminname_eq;
        if(!StringUtils.isEmpty(this.n_sysadminname_eq)){
            this.selectCond.eq("sysadminname", n_sysadminname_eq);
        }
    }
	private String n_sysadminname_like;

	public void setN_sysadminname_like(String n_sysadminname_like) {
        this.n_sysadminname_like = n_sysadminname_like;
        if(!StringUtils.isEmpty(this.n_sysadminname_like)){
            this.selectCond.like("sysadminname", n_sysadminname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_SYSADMINFUNC_SYSADMIN_SYSADMINID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_sysadminid_eq("NA");
			}
			else{
				this.setN_sysadminid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("sysadminfuncname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}